/* R-U-ON Tickets plugin          */
/* Copyright (c) 2006 R-U-ON LLC */
/* www.r-u-on.com                */

var sevBitmaps = [];
sevBitmaps['Critical'] = graphics.loadImage("critical.gif");
sevBitmaps['Major'] = graphics.loadImage("major.gif");
sevBitmaps['Minor'] = graphics.loadImage("minor.gif");
sevBitmaps['Closed'] = graphics.loadImage("clear.gif");
sevBitmaps['Resolved'] = graphics.loadImage("resolved.gif");
clearBitmap = graphics.loadImage("clear.gif");

var sevColors = [];
sevColors['Critical'] = "#FFCF9C";
sevColors['Major'] = "#FFE7AD";
sevColors['Minor'] = "#FFFFAD";
sevColors['Resolved'] = "#C7EAFA";
sevColors['Closed'] = "#BBFDA8";

var ticketsItems = [];

contentArea.contentFlags = gddContentFlagHaveDetails;

onTimer();    
setInterval(onTimer, 1000 * 60 * 60);  // Sixty minutes

function snippet(ticket) {
    var html = '<html><head></head><body style="font-family:arial;font-size:8pt">';
    var color = sevColors[ticket['severity']];
    var ignore = {"severity":true, "link":true, "Opened By Trunc":true, "TRK#":true, "Title":true };

    for (i in ticket) {
        if (ignore[i]) {
            continue;
        }
        if (i=="Severity") {
            html+="Severity: ";
            html+='<span style="background-color:'+color+'">&nbsp;'+ticket['Severity']+"&nbsp;</span>";
        } else {
            html+=(i+": "+ticket[i]);
        }
        html+="<br>";
    }

    html+="</body></html>";
    return html;
}

function noTickets() {

    var tm = new Date();
    tm.setMinutes(tm.getMinutes() + tm.getTimezoneOffset());
    
    var item = new ContentItem();
    item.heading = 'No tickets';
    item.time_created = tm.getVarDate();
    item.layout = gddContentItemLayoutEmail;
    item.flags = gddContentItemFlagStatic;
        
    contentArea.addContentItem(item, gddItemDisplayInSidebar);
}

function createStatus() {
    contentArea.removeAllContentItems();
    
    var statusItem = new ContentItem();
    statusItem.layout = gddContentItemLayoutNews;
    statusItem.onDetailsView = NoDetails;

    var tm = new Date();
    tm.setMinutes(tm.getMinutes() + tm.getTimezoneOffset());
    statusItem.time_created = tm.getVarDate();
    statusItem.flags = gddContentItemFlagStatic;
    
    contentArea.addContentItem(statusItem, gddItemDisplayInSidebar);
    
    for (var i=0;i<ticketsItems.length;++i) {
        contentArea.addContentItem(ticketsItems[i], gddItemDisplayInSidebar);
    }
    return statusItem;
}

function NoDetails(item) {
    return null;
}

function setStatus(s) {
    var statusItem = createStatus();
    statusItem.source = s;
}

function setError(s) {
   var statusItem = createStatus();
   statusItem.snippet = s;
    
   statusItem.onDrawItem = ErrDraw;         
   statusItem.onGetHeight = ErrHeight;   
}

function ErrHeight(item, target, graphics, width) {
    var h = graphics.GetTextHeight(item.snippet, width, gddTextFlagWordBreak, gddFontNormal);
    return h*2+2;
}

function ErrDraw(item, target, graphics, x, y, width, height) {
    graphics.DrawText(x, y+height/2-1, width, height, item.snippet, "#ff0000", gddTextFlagWordBreak, gddFontNormal);
}

function setInstruction(msg, instruction, url) {
    var statusItem = createStatus();
    statusItem.snippet = msg;
    statusItem.source = instruction;
    statusItem.open_command = url;
    statusItem.flags = gddContentItemFlagNoRemove;
    
    statusItem.onDrawItem = InstDraw;         
    statusItem.onGetHeight = InstHeight;   
}

function InstHeight(item, target, graphics, width) {
    var h = graphics.GetTextHeight(item.snippet, width, gddTextFlagWordBreak, gddFontNormal)+5;
    if (item.source!=null && item.source!='') {
        h+=graphics.GetTextHeight(item.source, width, gddTextFlagWordBreak, gddFontExtraInfo)+10;
    } 
    return h;
}

function InstDraw(item, target, graphics, x, y, width, height) {
 
    graphics.DrawText(x, y+5, width, height, item.snippet, gddColorNormalText, gddTextFlagWordBreak, gddFontNormal);
    if (item.source!=null && item.source!='') {
        var h = graphics.GetTextHeight(item.snippet, width, gddTextFlagWordBreak, gddFontNormal)+5;
        graphics.DrawText(x, h+10, width, height, item.source, gddColorExtraInfo, gddTextFlagWordBreak, gddFontExtraInfo);
    } 
}

function showTickets(tickets) {

    contentArea.removeAllContentItems();
    contentArea.maxContentItems = tickets.length+2;
    ticketsItems = [];
    
    if (tickets.length==0) {
        noTickets();
        return;
    } 
    
    setStatus("Last update");

    for (var i = tickets.length-1;i>=0;--i) {

        var item = new ContentItem();
        item.heading = tickets[i]['TRK#']+"    "+tickets[i]["Opened By Trunc"];
        item.source = tickets[i]['Title'];
        item.snippet = snippet(tickets[i]);
        item.open_command = tickets[i]['link'];
        item.flags = gddContentItemFlagPinned + gddContentItemFlagNoRemove + gddContentItemFlagShareable;
        item.layout = gddContentItemLayoutEmail;
        item.image = sevBitmaps[tickets[i]['severity']];
        
        item.onDrawItem = DrawItem;         
        item.onGetHeight = GetItemHeight;   
        item.onDetailsView = onDetailsView;

        contentArea.addContentItem(item, gddItemDisplayInSidebar);
        ticketsItems[ticketsItems.length] = item;
    }
}

function onDetailsView(item) {

    var control = new DetailsView();
    var tm = new Date(''+item.time_created);
    tm.setMinutes(tm.getMinutes() + tm.getTimezoneOffset());
    control.SetContent(item.source, 0, item.snippet, false, item.layout);
    control.html_content = true;

    var details = new Object();
    details.details_control = control;
    details.title = "TRK #"+item.heading.split(" ")[0];
  
    return details;


    var control = new DetailsView();
    var tm = new Date(''+item.time_created);
    //tm.setMinutes(tm.getMinutes() + tm.getTimezoneOffset());
    
    //control.SetContent("Blah Blah", tm, item.snippet, false, item.layout);
    
    control.html_content = true;

    var details = new Object();
    details.details_control = control;
    details.title = "Title !!!";
  
    return details;
}

function GetItemHeight(item, target, graphics, width) {
    return 2 + 2*graphics.GetTextHeight(item.heading, width, 0, gddFontNormal)+3;
}

function DrawItem(item, target, graphics, x, y, width, height) {
 
    graphics.DrawText(x, y, width-40, height/2, item.heading, gddColorNormalText, 0, gddFontNormal);
    graphics.DrawImage(width-40, y, 40, 14, item.image, 100);


    var rsrc = item.source.split("  -  ");
    var slack = 2;
    var w1 = graphics.GetTextWidth(rsrc[0], 0, gddFontExtraInfo);
    var w2 = graphics.GetTextWidth(rsrc[1], 0, gddFontExtraInfo);

    if (width-w1-slack<w2) {
        // ...
        var w3 = graphics.GetTextWidth("...", 0, gddFontExtraInfo);
        graphics.DrawText(x+w1+slack, y+height/2+1, w3, height/2, "...", gddColorSnippet, 0, gddFontExtraInfo);
        graphics.DrawText(x+w1+slack+w3, y+height/2+1, width-w1-slack-w3, height/2, rsrc[1], gddColorSnippet, gddTextFlagRight, gddFontExtraInfo);
    } else {
        graphics.DrawText(x+w1+slack, y+height/2+1, width-w1-slack, height/2, rsrc[1], gddColorSnippet, gddTextFlagRight, gddFontExtraInfo);
    }

    graphics.DrawText(x, y+height/2+1, width, height/2, rsrc[0], gddColorSnippet, 0, gddFontExtraInfo);
}

function parseTicket(node) {
    var ticket = new Array();
    var title = node.getElementsByTagName("title")[0].firstChild.nodeValue;
    var link = node.getElementsByTagName("link")[0].firstChild.nodeValue;
    var cdata = node.getElementsByTagName("description")[0].firstChild.nodeValue;

    var ix = title.indexOf(": ");
    ticket['TRK#'] = title.substr(1, ix-1);
    ticket['Title'] = title.substr(ix+2, title.length-ix-2);
    ticket['link'] = link;

    var cp = cdata.split("<br>");
    for (var i=0;i<cp.length;++i) {
        var nv = cp[i].split(": ");
        ticket[nv[0]] = nv[1];
    }
    if (ticket["Status"]=="Closed") {
        ticket["severity"] = "Closed";
    } else if (ticket["Status"]=="Resolved") {
        ticket["severity"] = "Resolved";
    } else {
        ticket["severity"] = ticket["Severity"];
    }
    ticket["Opened By Trunc"] = emailName(ticket["Opened By"]);

    return ticket;
}

function emailName(email) {
    if (email==null) {
        return null;
    }
    var ix = email.indexOf("@");
    if (ix==-1) {
        return  email;
    }
    return email.substr(0, ix);
}

function parseTickets(text) {
    try {   
        var doc = new DOMDocument();
        doc.loadXML(text);
        
        var rss = doc.getElementsByTagName("rss")[0];
        var channel = doc.getElementsByTagName("channel")[0];
        var items = doc.getElementsByTagName("item");

        if (items.length==1) {
            var title = items[0].getElementsByTagName("title")[0].firstChild.nodeValue;
            if (title=="R-U-ON Feed Exception") {
                var cdata = items[0].getElementsByTagName("description")[0].firstChild.nodeValue;
                setError("R-U-ON returned an error: \r\n"+cdata);
                return null;
            }
        }

        
        var tickets = [];
        for (var i=0;i<items.length;++i) {
            tickets[i] = parseTicket(items[i]);
        }

        return tickets;
    } catch(e) {
        setError(e.message+"\r\n\r\n(Internal Error)");
        return null;
    }
}

function onTimer()
{
    gadget.debug.error("here");

    var guid = options("guid");

    if (guid==null || guid=="") {
        setInstruction("Go to the Options window to enter account information.",
                       "Double click to create an account.",
                       "http://www.r-u-on.com/ctrl?action=newaccount");
        return;
    }
    
    setStatus("Loading...");

    var url = "http://rss.r-u-on.com/rsstickets?ggadget&id=" + guid;
    
    var req = new XMLHttpRequest();
    req.onreadystatechange = tickets;
    req.open("GET", url, true);
    req.send();

    function tickets() {
        if (req.readyState == 4) {
            if (req.status == 200) {
                var tickets = parseTickets(req.responseText);
                if (tickets!=null) {
                    try {
                        showTickets(tickets);
                    } catch (e) {
                        alert(e);
                    }
                }
            } else if (req.status==500) {
                if (req.responseText.indexOf("no such account")>0) {
                    setError("Account id invalid - try to login again (Options window)");
                } else {
                    setError("Server encountered an internal error - Please try again later (Refresh)");
                }
            } else {
                setError("Service/Network unavailable");
            }
        }
    }
}


